import {Component, OnInit, ViewChild} from '@angular/core';
import {MatSort, MatTableDataSource} from '@angular/material';
import {FormControl, FormGroup, FormBuilder, Validators} from '@angular/forms';
import {MomentModule} from 'angular-moment';
import * as moment from 'moment';

@Component({
  selector: 'app-reactform',
  templateUrl: './reactform.component.html',
  styleUrls: ['./reactform.component.css']
})
export class ReactformComponent implements OnInit {
   reactiveForm: FormGroup;
   unamePattern = '/^\d+$/';
   finalstring: String = '';
   numberRegex: any;
    re = /^\d{1,2}\/\d{1,2}\/\d{4}$/;

  constructor(private fb: FormBuilder) {
  this.numberRegex = /^\d+$/; }
// validateDate(){
// 	if(this.reactiveForm.get('expDate').value != '' && !this.reactiveForm.get('expDate').value.match(this.re)) {
//       alert("Invalid date format: " + this.reactiveForm.get('expDate').value);
//       //form.startdate.focus();
//       //return false;
//     }
// }

validateDate(value){
	var datefield = moment(value);
	if (!datefield.isValid()){
		alert('Invalid Date');
	}

}

// validateDate(value){
// 	if (!this.isvalidateDate(value)){
// 		alert('Invalid Date');
// 	}

// }
 isvalidateDate(value) {

    if ((value !== undefined && value !== '' && value != null)) {
        var month = null;
        var day = null;
        var year = null;
        if (value.indexOf('/') > -1) {
            var res = value.split("/");           
            if (res.length > 1) {
                month = res[0];
                day = res[1]
                year = res[2];
            }  
            console.log('month: ' + month  + ", "+ 'day: ' + day + ", " + 'year: ' + year);                            
        }
       
        if (month < 1 || month > 12) { // check month range
            return false;
        }
        if (day < 1 || day > 31) {
            return false;
        }
        if(year.length > 4) {return false;}
        
        if (month === 2) { // check for february 29th
            var isleap = (year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0));
            if (day > 29 || (day === 29 && !isleap)) {
                return false;
            }
        }
        return true;
    }
    
    }

createForm() {
this.reactiveForm = this.fb.group({
expDate: ['', Validators.required],
userName: [''],
capacity: ['100', Validators.required]
});
}

ngOnInit() {
this.createForm();
}
  // let newstring: any; let finalstring: any = ""; let str: any;
  //   	newstring = this.reactiveForm.get('userName').value;
  //   	str = newstring.split(' ');
  //   	console.log('str: ' + str);
  //   	for(let i=0; i < str.length ; i ++){
  //      finalstring += "/.*" + str[i] + ".*/";
  //       }
  //       console.log('finalstring: ' + finalstring);
onFocusOut() {
this.splitString(this.reactiveForm.get('userName').value);
console.log('finalstring: ' + this.finalstring);
}
splitString(columnValue) {
const str = columnValue.split(' ');
for (let i = 0; i < str.length ; i++) {
this.finalstring += '/.*' + str[i] + '.*/';
        }
        return this.finalstring;
}

onKeydown(e) {
// if (this.reactiveForm.get('capacity').value > 100 ){
if (e > 100 ) {
this.reactiveForm.get('capacity').setValue('100');
// this.reactiveForm.get('capacity').setErrors(new Error('Enter value less than 100'));
}
}

onSave() {
console.log('button clicked');
console.log('capacity value: ' + this.reactiveForm.get('capacity').value);
}
}
