import {NgModule} from '@angular/core';
import {RouterModule, Routes} from '@angular/router';
import { UIMatComponent } from './uimat/uimat.component';
import { ReactformComponent } from './reactform/reactform.component';
import {LoginComponent} from './login/login.component';
import { UitestComponent } from './uitest/uitest.component';


const appRoutes: Routes = [
{path: 'uimatinput', component: UIMatComponent},
{path: 'reactform', component: ReactformComponent},
{path: '', component: LoginComponent},
{path: 'login', component: LoginComponent},
{path: 'uitest', component: UitestComponent},

// {path: '**', component:PagenotfoundComponent}
];

@NgModule({
    imports: [RouterModule.forRoot(appRoutes, {useHash: true})],
    exports: [RouterModule]
})

export class AppRouting {}
