import { Directive, Input, HostListener, ElementRef } from '@angular/core';

@Directive({
  selector: '[appRestrictuserinput]'
})
export class RestrictuserinputDirective {

  @Input()
    regexPattern: any;
    constructor(private el: ElementRef) {

    }
    @HostListener('keypress', ['$event'])
    handleKeypress(evt) {
        console.log(this.regexPattern);
        console.log(evt);
        const myRegex = new RegExp(this.regexPattern);
        if (myRegex.test(evt.key)) {
            console.log('if: ' + evt.key);
            // evt.preventDefault();
        } else {
            console.log('else: ' + evt.key);
            evt.preventDefault();
        }
    }

}
