import { async, ComponentFixture, TestBed } from '@angular/core/testing';
import {FormBuilder, FormsModule, FormGroup, ReactiveFormsModule} from '@angular/forms';
import { LoginComponent } from './login.component';
import {NO_ERRORS_SCHEMA, NgModule, DebugElement} from '@angular/core';
import {RouterModule, Router} from '@angular/router';
import { By } from '@angular/platform-browser';

fdescribe('LoginComponent', () => {
  let component: LoginComponent;
  let fixture: ComponentFixture<LoginComponent>;
  
  beforeEach(async(() => {
    let router: Router;
    TestBed.configureTestingModule({
      declarations: [ LoginComponent ],
      schemas: [NO_ERRORS_SCHEMA],
      imports: [ReactiveFormsModule,RouterModule],
      providers: [
      {provide: Router, useValue: router}
      ]
    })
    .compileComponents();
  }));

  beforeEach(() => {
    fixture = TestBed.createComponent(LoginComponent);
    component = fixture.componentInstance;
    fixture.detectChanges();
  });
  it('1.should create Login Component', () => {
    expect(component).toBeTruthy();
  });
  it('2.should create instance of Login Component', () => {
    expect(component).toBeDefined();
  });
  it('3.should call ngOnInit', () => {
  component.ngOnInit();
  //expect(component).toContain(component.createForm());
});
  it('4. should find the <h2> with fixture.debugElement.query(By.css)', () => {
  const bannerDe: DebugElement = fixture.debugElement;
  const headingDe = bannerDe.query(By.css('h2'));
  const h: HTMLElement = headingDe.nativeElement;
  expect(h.textContent).toEqual('Login');
});
  it('5.should call ngOnInit', () => {
  let isloading = false;
  expect(component.isLoading).toMatch('false');
  fixture.detectChanges();
  component.onEditButtonClick();
        expect(console.log).toHaveBeenCalledWith('Edit button has been clicked!);
  //expect(component.isLoading).toMatch('true');
  //expect(component).toContain(component.createForm());
});
   // it('should create a `FormGroup` comprised of `FormControl`s', () => {
   //      component.ngOnInit();
   //      expect(component.heroForm instanceof FormGroup).toBe(true);
   //  });

});
