import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import {MatInput} from '@angular/material';
import {FormControl, FormGroupDirective, NgForm, Validators} from '@angular/forms';
import {ErrorStateMatcher} from '@angular/material/core';
import {MatDatepickerInputEvent} from '@angular/material/datepicker';
import { FileUploaderService, FileQueueObject } from '../file-uploader.service';
import * as XLSX from 'xlsx';
type AOA = any[][];

@Component({
  selector: 'app-uimat',
  templateUrl: './uimat.component.html',
  styleUrls: ['./uimat.component.css']
})
export class UIMatComponent  extends ErrorStateMatcher  implements OnInit {
@ViewChild('pwd', { read: MatInput }) pwd: MatInput;
alphabetsAndSpaceRegex: any;
numberRegex: any;

testFileObj: any;
fdata: any = [];
  fileUploadObj: any;
  fileInformation: any = [];
  data: AOA = [ [1, 2], [3, 4] ];

  emailFormControl = new FormControl('', [
    Validators.required,
    Validators.email,
  ]);

  matcher = new ErrorStateMatcher();
  constructor(public fileUploadService: FileUploaderService) {
    super();
  this.alphabetsAndSpaceRegex = /^[a-zA-Z\s]*$/;
  this.numberRegex = /^\d+$/;
  }

  ngOnInit() {
    this.pwd.focus();
  }
  

  // public exportAsExcelFile(json: any[], excelFileName: string): void {
  //   const worksheet: XLSX.WorkSheet = XLSX.utils.json_to_sheet(json);
  //   const workbook: XLSX.WorkBook = { Sheets: { 'data': worksheet }, SheetNames: ['data'] };
  //   const excelBuffer: any = XLSX.write(workbook, { bookType: 'xlsx', type: 'buffer' });
  //   this.saveAsExcelFile(excelBuffer, excelFileName);
  // }

  // private saveAsExcelFile(buffer: any, fileName: string): void {
  //   const data: Blob = new Blob([buffer], {
  //     type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=UTF-8"
  //   });
  //   var today = new Date();
  //   var date = today.getFullYear() + '' + (today.getMonth() + 1) + '' + today.getDate() + '_';
  //   var time = today.getHours() + "-" + today.getMinutes() + "-" + today.getSeconds();
  //   var name = fileName + date + time;
  //   FileSaver.saveAs(data, name + ".xlsx");
  //   }
  

saveFile(){
  const worksheet: XLSX.WorkSheet = XLSX.utils.aoa_to_sheet(this.data);
    /* generate workbook and add the worksheet */
    const wb: XLSX.WorkBook = XLSX.utils.book_new();
    XLSX.utils.book_append_sheet(wb, worksheet, 'Sheet1');
    /* save to file */
    XLSX.writeFile(wb, 'test.xlsx');

}
  addEvent(type: string, event: MatDatepickerInputEvent<Date>) {
    const even = event.value;
    console.log('even' + even);
  }

    /* file upload */
    receiveMessage($event) {
      console.log($event);
      this.testFileObj = $event;
    }
    onCompleteItem($event) {
      this.fdata.push($event.response);
      if (this.fileInformation.length > 0) {
        this.fileInformation.forEach(file => {
          this.fdata.push(file);
        })
      }
    }
    uploadFileCom() {
      this.fileUploadService.uploadAll();
      // if (this.testFileObj === undefined || this.testFileObj === null) {
      
      // }
    }

    
}



