import { Component, OnInit, ViewChild, Input } from '@angular/core';
import { TreeTable, TreeNode } from 'primeng/primeng';
import { NodeService } from '../../node.service';
import {MatSort, MatTableDataSource} from '@angular/material';
import {TableModule} from 'primeng/table';
import * as XLSX from 'xlsx';
import { NgProgress } from 'ngx-progressbar';
import {MatSnackBar} from '@angular/material';
export interface Car {
  year: string;
  brand: string;
  color: string;
}

@Component({
  selector: 'app-uitest',
  templateUrl: './uitest.component.html',
  styleUrls: ['./uitest.component.css']
})
export class UitestComponent implements OnInit {
//AOA = any[][];
data = [ [1, 2], [3, 4] ];
cars ; cars1: Car[];

  constructor(public ngProgress: NgProgress, public snackBar: MatSnackBar){
    
  }
  ngOnInit(){
    this.cars = [{year: '2016', brand: 'Hydrogen', color: 'Red'},
    {year: '2015', brand: 'Helium', color: 'Orange'},
    {year: '2017', brand: 'Lithium', color: 'Green'}];
    this.cars1 = [
      {year: '2016', brand: 'Hydrogen', color: 'Red'},
      {year: '2015', brand: 'Helium', color: 'Orange'},
      {year: '2017', brand: 'Lithium', color: 'Green'},
      {year: '2018', brand: 'Xenon', color: 'Violet'},
      {year: '2019', brand: 'Sulphur', color: 'Purple'},
      {year: '2020', brand: 'Nitrogen', color: 'Skyblue'}
    ];
  }
  ishidden: boolean = false;


  progress: any;
saveFile() {
  
  const worksheet: XLSX.WorkSheet = XLSX.utils.json_to_sheet(this.cars1);
    /* generate workbook and add the worksheet */
    const wb: XLSX.WorkBook = XLSX.utils.book_new();
    XLSX.utils.book_append_sheet(wb, worksheet, 'Sheet1');
    /* save to file */
    XLSX.writeFile(wb, 'test.xls', { bookType: 'xls', type: 'buffer' });
    
}
  keyPress(event: any) 
    {
      //const pattern = /[a-zA-Z0-9 ]/g;
      const pattern = /[0-9 ]/g;
      let inputChar = String.fromCharCode(event.charCode);
        
      // if(event.keyCode != 8 && event.keyCode != 37 && event.keyCode != 38 && event.keyCode != 39 && event.keyCode != 40 && event.keyCode != 9 && event.keyCode != 46 && !pattern.test(inputChar)) 
      //  {
      //    event.preventDefault();
      //   }
        // if (event.keyCode > 31 && (event.keyCode < 48 || event.keyCode > 57)) {
        // event.preventDefault();
        // }
        if (event.keyCode > 31 && (event.keyCode < 45 || event.keyCode > 57) || (event.keyCode == 47) ) {
        event.preventDefault();
        }
   }
   onKeydown(e){
    if (e > 10 && e < 100 ){
       alert('number cannot be greater than 10 to 100'); 
    }
  }
  checkFilter(){
    var first = [{ "id": 1, "name": "python" }, { "id": 2, "name": "NodeJs" }, { "id": 3, "name": "git" }];
    var selectedExpTags = [1,2];
    var names = first.filter(item => selectedExpTags.some(id => item.id === id)).map(item => item.name);
    console.log(names);
  }

}